package managedbeans;

import java.io.Serializable;

import org.eclnt.editor.annotations.CCGenClass;
import org.eclnt.jsfserver.defaultscreens.Statusbar;
import org.eclnt.jsfserver.elements.impl.FIXGRIDItem;
import org.eclnt.jsfserver.elements.impl.FIXGRIDListBinding;
import org.eclnt.jsfserver.pagebean.PageBean;
import org.eclnt.jsfserver.session.RequestFocusManager;

@CCGenClass(expressionBase = "#{d.TestGridRowExecuteFlush}")
public class TestGridRowExecuteFlush extends PageBean implements Serializable {

	FIXGRIDListBinding<GridItem> m_grid = new FIXGRIDListBinding<GridItem>();

	public class GridItem extends FIXGRIDItem implements java.io.Serializable {
		String i_value1 = "";
		String i_value2 = "";
		long i_field1RF;
		long i_field2RF;
		String field1bgpaint = "";
		String field2bgpaint = "";

		public void onRowSelect() {
		}

		public void onRowExecute() {
			System.err.println("onRowExecute");
			onSave(null);
		}

		public String getValue1() {
			return i_value1;
		}

		public void setValue1(String value1) {
			this.i_value1 = value1;
		}

		public String getValue2() {
			return i_value2;
		}

		public void setValue2(String value2) {
			this.i_value2 = value2;
		}

		/**
		 * Don't process AFTER rowExecute
		 * @param event
		 */
		public void onlushField1(javax.faces.event.ActionEvent event) {
			System.err.println("onlushField1");
			boolean ok1 = "1".equals(i_value1);
			if (!ok1) {
				setField1RF(RequestFocusManager.getNewRequestFocusCounter());
				setField1bgpaint("error()");
				Statusbar.outputError("Error1");
			} else {
				setField1bgpaint("");
			}
		}

		/**
		 * Don't process AFTER rowExecute
		 * @param event
		 */
		public void onlushField2(javax.faces.event.ActionEvent event) {
			System.err.println("onlushField2");
			boolean ok2 = "2".equals(i_value2);
			if (!ok2) {
				setField2RF(RequestFocusManager.getNewRequestFocusCounter());
				setField2bgpaint("error()");
				Statusbar.outputError("Error2");
			} else {
				setField2bgpaint("");
			}
		}

		public long getField1RF() {
			return i_field1RF;
		}

		public void setField1RF(long field1rf) {
			i_field1RF = field1rf;
		}

		public long getField2RF() {
			return i_field2RF;
		}

		public void setField2RF(long field2rf) {
			i_field2RF = field2rf;
		}

		public String getField1bgpaint() {
			return field1bgpaint;
		}

		public void setField1bgpaint(String field1bgpaint) {
			this.field1bgpaint = field1bgpaint;
		}

		public String getField2bgpaint() {
			return field2bgpaint;
		}

		public void setField2bgpaint(String field2bgpaint) {
			this.field2bgpaint = field2bgpaint;
		}

	}

	// ------------------------------------------------------------------------
	// inner classes
	// ------------------------------------------------------------------------

	/* Listener to the user of the page bean. */
	public interface IListener {
	}

	// ------------------------------------------------------------------------
	// members
	// ------------------------------------------------------------------------

	private IListener m_listener;

	// ------------------------------------------------------------------------
	// constructors & initialization
	// ------------------------------------------------------------------------

	public TestGridRowExecuteFlush() {
		GridItem gi = new GridItem();
		m_grid.getItems().clear();
		m_grid.getItems().add(gi);

		gi.setField1RF(RequestFocusManager.getNewRequestFocusCounter());
	}

	public String getPageName() {
		return "/gridRowExecuteFlush.jsp";
	}

	public String getRootExpressionUsedInPage() {
		return "#{d.TestGridRowExecuteFlush}";
	}

	// ------------------------------------------------------------------------
	// public usage
	// ------------------------------------------------------------------------

	/* Initialization of the bean. Add any parameter that is required within your scenario. */
	public void prepare(IListener listener) {
		m_listener = listener;
	}

	public void onSave(javax.faces.event.ActionEvent event) {
		System.err.println("onSave");
		if (check()) {
			Statusbar.outputSuccess("Saved!");
		} else {

		}
	}

	// ------------------------------------------------------------------------
	// private usage
	// ------------------------------------------------------------------------

	private boolean check() {
		System.err.println("check");
		GridItem gridItem = m_grid.getItems().get(0);

		boolean ok1 = "1".equals(gridItem.getValue1());
		boolean ok2 = "2".equals(gridItem.getValue2());

		if (!ok1) {
			gridItem.setField1RF(RequestFocusManager.getNewRequestFocusCounter());
			gridItem.setField1bgpaint("error()");
			Statusbar.outputError("Error1");
		} else {
			gridItem.setField1bgpaint("");
		}
		if (!ok2) {
			gridItem.setField2RF(RequestFocusManager.getNewRequestFocusCounter());
			gridItem.setField2bgpaint("error()");
			Statusbar.outputError("Error2");
		} else {
			gridItem.setField2bgpaint("");
		}
		return ok1 && ok2;
	}

	// ------------------------------------------------------------------------
	// getter / setter
	// ------------------------------------------------------------------------

	public FIXGRIDListBinding<GridItem> getGrid() {
		return m_grid;
	}

}
